#include <iostream>
#include <vector>
#include <string>
#include <fstream>
#include <sstream>
#include <queue>
#include <set>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <limits>
#include <algorithm>

using namespace std;

// 全局变量：地图、行列数、起点、终点及所有配送点
vector<string> grid;
int M, N;
pair<int,int> startPos, targetPos;
vector<pair<int,int>> specialPoints;

// 状态表示：当前行、列、累计耗电（步数）以及已收集的配送点
struct State {
    int r, c;
    int cost;
    set<pair<int,int>> collected;
};

// TODO: 判断坐标是否合法：在边界内且非障碍
bool validPos(int r, int c) {
    
}

// TODO: 判断状态是否为终止状态：所有配送点都已收集且当前位置为终点
bool isTerminalState(const State &s) {
    
}

// TODO: 获取当前状态的所有合法后继状态及对应动作（U、D、L、R）
vector<pair<State, char>> getSuccessors(const State &s) {
    vector<pair<State, char>> successors;
    vector<pair<int,int>> directions = { {-1,0}, {1,0}, {0,-1}, {0,1} };
    for (int i = 0; i < 4; i++) {
        
    }
    return successors;
}

// MCTS 节点定义
struct Node {
    State state;
    Node* parent;
    vector<Node*> children;
    int visits;
    double totalReward;
    char action;
    string path;

    Node(const State &s, Node* p = nullptr, char act = ' ')
        : state(s), parent(p), visits(0), totalReward(0.0), action(act) {
        if (p)
            path = p->path + act;
        else
            path = "";
    }
};

// TODO: UCT公式计算子节点价值
double uctValue(Node* child, int totalVisits) {
    
}

// TODO: 1. 选择：从根节点开始，沿UCT公式选择直至遇到未完全扩展的节点或终止状态
Node* select(Node* root) {

}

// TODO: 2. 扩展：为当前节点扩展一个未尝试过的动作
Node* expand(Node* node) {
    
}

// TODO: 3. 模拟：从当前状态随机走步至终止状态或达到步数上限，并返回回报(回报 = -cost，耗电少则回报高)
// 大家也可以采用启发式模拟
double simulate(State s) {
    
}

// TODO: 4. 反向传播：将模拟获得的回报沿路径向上传播更新
void backpropagate(Node* node, double reward) {

}

// MCTS 主循环
Node* mcts(Node* root, int iterations) {
    // TODO: 在指定迭代次数内搜索
    for (int i = 0; i < iterations; i++) {
        
    }
    // TODO: 从根节点选择平均回报最高的子节点作为最佳分支
    Node* best = nullptr;
    double bestAvg = -numeric_limits<double>::infinity();
    for (Node* child : root->children) {

    }
    return best;
}

// 释放搜索树内存
void deleteTree(Node* root) {
    for (Node* child : root->children) {
        deleteTree(child);
    }
    delete root;
}

// MCTS搜索函数：读取输入文件，构建地图与状态，进行 MCTS 搜索，并返回路径及耗电数
void MCTS_search(const string &input_file, int &step_nums, string &way) {
    ifstream fin(input_file);
    if (!fin.is_open()) {
        cout << "Error opening file: " << input_file << endl;
        return;
    }
    
    vector<string> input_map;
    string line;
    while(getline(fin, line)) {
        if (!line.empty())
            input_map.push_back(line);
    }
    fin.close();
    
    if (input_map.empty()) {
        cout << "Error: Empty map file!" << endl;
        return;
    }
    
    // 初始化全局地图变量
    M = input_map.size();
    N = input_map[0].size();
    grid = input_map;
    
    // 扫描地图，找出起点S、终点T以及所有配送点B
    specialPoints.clear();
    for (int i = 0; i < M; i++) {
        for (int j = 0; j < N; j++) {
            char ch = grid[i][j];
            if (ch == 'S')
                startPos = {i, j};
            else if (ch == 'T')
                targetPos = {i, j};
            else if (ch == 'B')
                specialPoints.push_back({i, j});
        }
    }
    
    // 初始状态
    State init;
    init.r = startPos.first;
    init.c = startPos.second;
    init.cost = 0;
    if (grid[startPos.first][startPos.second] == 'B')
        init.collected.insert(startPos);
    
    // 建立根节点并进行 MCTS 搜索
    Node* root = new Node(init);
    int MAX_ITER = 10000;  // TODO: 可根据需要调参
    srand(time(0));
    Node* bestNode = mcts(root, MAX_ITER);
    
    // 若搜索得到满足目标的节点则返回路径及cost，否则返回 -1
    if (bestNode == nullptr || !isTerminalState(bestNode->state)) {
        step_nums = -1;
        way = "";
    } else {
        step_nums = bestNode->state.cost;
        way = bestNode->path;
    }
    
    deleteTree(root);
}

// 输出结果到文件
void output_result(const string &output_file, int step_nums, const string &way) {
    ofstream fout(output_file);
    if (fout.is_open()){
        fout << step_nums << endl;
        if (step_nums > 0)
            fout << way << endl;
        fout.close();
    } else {
        cerr << "Cannot open file: " << output_file << endl;
    }
}

int main() {
    clock_t start_time, end_time;
    start_time = clock();
    string input_base = "../input/input_";
    string output_base = "../output/output_";
    // 从input_1.txt到input_10.txt进行搜索，input_0.txt已用作演示
    for (int i = 0; i <= 0; i++) {
        int step_nums = -1;
        string way = "";
        MCTS_search(input_base + to_string(i) + ".txt", step_nums, way);
        output_result(output_base + to_string(i) + "_mcts.txt", step_nums, way);
    }
    end_time = clock();
    cout << "time = " << double(end_time - start_time) / CLOCKS_PER_SEC << "s" << endl;
    return 0;
}